/* This is the file exc.h
 * It is the header file for the exception handling code and must be included
 * by any module using exceptions.
 * Modified on 19th August 1986 - Linked list for exception contexts.
 */
#if ! defined(ExC_h)
#define ExC_h
#include <setjmp.h>
#define EXCMAXNEST 16
typedef char near *exception;
struct ExcContext {
   struct ExcContext *link;
   jmp_buf env;
};

#define BEGIN {for(;;){ /* Start of exception handling context */\
                exception exc_code; struct ExcContext ExcMostRecent;\
                exc_begin(&ExcMostRecent);\
                if((int)(exc_code=(exception)setjmp(ExcMostRecent.env))==0)\
	        {for(;;){ /* start if */
#define EXCEPTION break; /* Leave inner loop */} exc_1leave();\
                } /* end if((exc_code... */\
                else\
                { /* start else clause */\
                  exc_2leave();\
                  if(0 /*i.e. FALSE */) {

#define WHEN(NAME) }else if(exc_code==(NAME)){
#define OTHERS exc_code
#define END } else exc_raise(exc_code);\
            } /* end else clause of if(exc_code... */\
            break; /* Leave outer loop */ }}
	    /* end of exception handling context */
#define exc_reraise() exc_raise(exc_code)
#define exc_repeat() continue
#define OR_WHEN )||exc_code==(
/*#define NEW_EXCEPTION(NAME) exception NAME="NAME"*/

/*extern jmp_buf ExcContext[EXCMAXNEST];*/
/*extern int ExcMostRecent;*/
extern int exc_trace;
extern struct ExcContext *ExcList;


/* Extended type declarations for Microsoft C v3.0 */
extern void exc_begin(struct ExcContext *);
extern void exc_1leave(void);
extern void exc_2leave(void);
extern void exc_raise(exception);
extern void exc_signal(exception);

/* Exceptions that this package may signal. They are delared in exc.c */
extern exception CONTROL_C, OP_FAILED, OUT_OF_MEMORY;

#endif /* if ! defined ExC_h... */
